$large
$nofloatcalls
c ***** read in parameters for simulation
c
      subroutine gpars(npar,par,seed)
      doubleprecision par(1)
      integer seed
c
c
      read(*,*) npar 

      if(npar.eq.0) return

      do 10 k= 1, npar
         read(*,*) par(k)
   10 continue
         read(*,*) seed
      return
      end

      SUBROUTINE YTEST(Y,N,LINK,JOB,IERR)
C Subroutine to check that not all the N Y-values are equal
C and the range of Y values.
      INTEGER N,LINK,IERR,JOB
      REAL*8 Y(N),Y1
      Y1=Y(1)
      DO 10 J=2,N
        IF(Y(J).NE.Y1) GOTO 20
10    CONTINUE
      IERR=1
      RETURN

20    CONTINUE
      IF(JOB.NE.1.AND.LINK.GT.1) THEN
	DO 30 I=1,N
	  IF(Y(I).LT.0) THEN
	     IERR=2
	     RETURN
	  ENDIF
	  IF(LINK.EQ.2.AND.Y(I).GT.1) THEN
	    IERR=3
	    RETURN
	  ENDIF
30	CONTINUE
      ENDIF
      RETURN
      END


      SUBROUTINE NOTIES(Y,X,IREP,NOBS,NDIM,NMAX)
C Collapses X to its unique rows, carrying Y and IREP along.
      REAL*8 X(NMAX,NDIM),Y(NMAX),T1,T2
      INTEGER IREP(NMAX)
      NEWN=NOBS
      I=1
10    CONTINUE
        J=I+1

20      CONTINUE
          ITIE=1
C         Compare x(i,*) to x(j,*), and set itie=0 if mismatch occurs
          DO 50 K=1,NDIM
            IF (X(I,K).NE.X(J,K)) THEN
              ITIE=0
              GOTO 200
            ENDIF
50        CONTINUE
          IF (ITIE.EQ.1) THEN
            T1=Y(I)*DBLE(IREP(I))
            T2=Y(J)*DBLE(IREP(J))
            Y(I)=(T1+T2)/ DBLE(IREP(I)+IREP(J))
            IREP(I)=IREP(I)+IREP(J)
            IF(J.LE.NEWN-1) THEN
              DO 105 KK=J, NEWN-1
                Y(KK)=Y(KK+1)
                IREP(KK)=IREP(KK+1)
                DO 110 M=1,NDIM
                  X(KK,M)=X(KK+1,M)
  110           CONTINUE
  105         CONTINUE
            ENDIF
            NEWN=NEWN-1
            IF(J.LE.NEWN) GOTO 20
          ENDIF
200     CONTINUE
        J=J+1
        IF(J.LE.NEWN) GOTO 20

      I=I+1
      IF (I.LE.NEWN-1) GOTO 10

      NOBS=NEWN
      RETURN
      END


      subroutine gdata(ldx,nobs,ndim,x,lrrep, irep,y,LINK,NREP)
      real*8 x(ldx,ndim),y(ldx)
c if lrrep is >0 then the number of replicates are expected.
      integer irep(ldx),NREP,NOBS,NDIM,LRREP,LINK
      character*40 fname

        read(*,10) fname
   10   format(a40)

        open(8,file=fname,status='old')

30      rewind(8)
	write (*,*)
     *    '# Filename =  ',fname

	NREP=0
        DO 55 i=1,ldx
         if(lrrep.eq.0) then 
          read (8,*,end=60,ERR=58) y(i),(x(i,k),k=1,ndim)
          irep(i)=1
         else
          read (8,*,end=60,ERR=58) y(i),(x(i,k),k=1,ndim), irep(i)
	  NREP=NREP+IREP(I)
	  IF(IREP(I).LT.1) THEN
	    WRITE(*,*) ' WARNING: data are read in as ( Y X1 X2 ... N )'
 	    WRITE(*,*) ' N must be >=1, check file row',i
	    STOP
	  ENDIF
         endif
55      continue

        write(*,*) ' CAUTION: max number of observations read= ' ,ldx
	NOBS=LDX
	GOTO 61

58	WRITE(*,*) ' Error when reading data---check file format'
	IF(LRREP.NE.0) WRITE(*,*) 
     *   ' Possible problem: last column of file must be an integer'
	STOP

60      nobs=i-1
61	CONTINUE
	IF(LRREP.EQ.0) NREP=NOBS
	write (*,'(a,i10)') 
     *    '# Number of cases read from file =       ',nobs
	write (*,'(a,i10)') 
     *    '# Total number of observations =         ',NREP

	CALL YTEST(Y,NOBS,LINK,2,IERR)
	IF(IERR.EQ.1) THEN
	  WRITE(*,*) ' WARNING: Fitness variable Y has no variance'
	  STOP
	ELSEIF(IERR.EQ.2) THEN
	  WRITE(*,*) 
     *    ' WARNING: Y<0 not allowed with binomial and poisson data'
	  STOP
	ELSEIF(IERR.EQ.3) THEN
	  WRITE(*,*) 
     *    ' WARNING: Y>1 not allowed with binomial data'
	  STOP
	ENDIF

	CALL NOTIES(Y,X,IREP,NOBS,NDIM,LDX)
	write (*,'(a,i10)') 
     *    '# Number of unique observations =        ',nobs

      return
      end

C link=1 means Y is Normal, equal variance
C link=2 means Y is Binomial
C link=3 means Y is Poisson       
C job  not equal to zero indicates that starting values will be 
C   previous estimate  
C
c Declarations
      subroutine glisp(lamb,npoint,x,y,sy,snu,snuc,CSS,tr,WSS,
     * maxit,stop,numit,tstop,job,link,itr,irep,LEV)
      parameter(nmax=800)
      implicit double precision (a-g,o-z)
      real*8 x(1),y(1),z(nmax),wt(nmax),sy(1),prvnu(nmax)
      real*8 snu(1),snuc(1),LEV(NMAX)
      real*8 ytonu,nutoy,nuhat,phi2,lamb,maxdf
      real*8 numax, numin,nfull
      integer irep(1),job,link
      data eps / 1e-6/
c 
c
       if(npoint.gt.nmax) then
            write(*,*) 'nobs= ',npoint,' too large for glisp'
            return
       endif

c      write(*,*) ' job, link',job, link

c DS created the following lines, to space out the x-points a bit,
c to prevent collapse to fewer points in smths (this circumvents
c the lines in smths to recalculate the number of nearly-unique obs)
       DO 5 I=1,NPOINT-1
	IF(X(I+1)-X(I).LT.EPS) X(I+1)=X(I)+EPS
5      CONTINUE

c DS moved the following lines higher up in the program (it was located
c just before the setup for first iteration below) because the normal case
c can also use avgy to compute the fit relative to a constant.

          yhat=0.0
          nt=0
          do 14 i=1,npoint
            yhat=yhat+y(i)*irep(i) 
            nt= irep(i) + nt
 14       continue
 
          yhat=yhat/nt
          avgy=yhat

c         write(*,*) ' yhat,  nt ', yhat, nt


 
c  Normal case:
        if( link.eq.1)  then 
          do 10 i=1,npoint
            wt(i)=1.0/dsqrt(dble(irep(i)))
            z(i)= y(i)- snuc(i)
 10       continue
          call smths(lamb,npoint,x,z,wt,snu,penlty,
     *               tr,WSS,itr,ierr,LEV)
C           Note: itr indicates whether the trace should be computed
	  WSS=0
          CSS=0
          do 11 i=1,npoint
            sy(i)= snu(i) + snuc(i)

c   sy is the full nonparametric function not just the current
c   ridge function being estimated.
c   compute weighted sum of squares (added by DS)
            WSS= WSS + IREP(I)*( (Y(I)-SY(I))**2 )
            CSS= CSS + IREP(I)*( (AVGY-SY(I))**2 )

 11       continue
          numit=-1
          tstop=0 
          return
        endif


c Set up initial estimates for first iteration
c if previous values are not available or should not be used
c See above for computation of yhat=avgy

       if( job.eq.0) then

c         A starting value of .5 for the binomial tends to be more stable:
	  if (link.eq.2) then 
             yhat= .5
c            write(*,*) ' start weights are the average'
          endif 


          nuhat=ytonu(yhat,link)
 
c compute psuedo-values and weights for first iteration

          do 15 i=1,npoint

               nfull= nuhat+ snuc(i)
               diag= phi2(nfull,link)
C              if( diag.lt.1e-12) diag=1e-12

               yhat= nutoy(nfull,link)
               z(i)=nuhat+(y(i)-yhat)/(diag)
               wt(i)=1.0/dsqrt(dble(irep(i))*diag)

c              if( i.le.20) then 
c              write(*, 88) i,x(i),y(i),irep(i), nuhat, wt(i),z(i)
c              endif

c 88        format( i5,2e12.4,i5, 3e13.5)

 15       continue
       endif

c Start iterating:
      maxdf=0.0
      numit= 0
      do 500 it=1,maxit

c fit a weighted least squares cubic smoothing spline

      call smths(lamb,npoint,x,z,wt,snu,penlty,tr,WSS,itr,ierr,LEV)
C           Note: itr indicates whether the trace should be computed

      if(ierr.eq.0) then
           write(*,*) 'nobs= ',npoint,' too large for smths'
           write(*,*) 'reset parameter statement in smths'
           return
      endif
cbug      if((ierr.lt.npoint).and.( ierr.gt.0)) then
cbug           write(*,*) 'nobs= ',npoint, ' unique observations= ',ierr
cbug      endif

CBUG
	IF(ITR.GE.1.AND.TR.LT.0) THEN
	WRITE(*,*) ' WARNING: negative trace =',TR
C	WRITE(*,*) ' Iteration is',it
C	WRITE(*,*) ' Here is also X, Z, Y, WT, SNUC, SNU, SY, IREP'
C	DO 898 L=1,NPOINT
C	WRITE(*,'(7F11.7,i5,f12.6)')
C     *	X(L),Z(L),Y(L),WT(L),SNUC(L),SNU(L),SY(L),IREP(L),LEV(L)
C898		CONTINUE
C	STOP
	ENDIF

c compute convergence criterion

          numin=snu(1)
          numax=numin
          maxdf=0.0
          do 25 i=1,npoint
               nuhat= snu(i)
               test=dabs(prvnu(i)-nuhat)
c max and min used in convergence criterion
               if(nuhat.lt.numin) numin=nuhat
               if(nuhat.gt.numax) numax=nuhat
               if(test.gt.maxdf) maxdf=test

c nfull is the full nonparametric function not just the current 
c ridge function being estimated. 
c The weights and new pseudovalues are based on nfull

               nfull= nuhat+ snuc(i)
               diag= phi2(nfull,link)
C               if( diag.lt.1e-12) diag=1e-12

c compute psuedo-values and weights for next iteration
               yhat= nutoy(nfull,link)
               z(i)=nuhat+(y(i)-yhat)/(diag)
               wt(i)=1.0/dsqrt(dble(irep(i))*diag)

c            if( i.le.20) then 
c           write(*, 88) i,x(i),y(i),irep(i), nuhat, wt(i),z(i)
c           endif

               prvnu(i)=nuhat
 25       continue
 
           tstop=(maxdf)/(numax-numin)
           
           if( tstop.lt.stop  ) then 
             numit=it
             goto 550 
           endif
c     write(*,*) it,tstop,tr
500   continue

      NUMIT=IT-1

550   continue

c compute predicted y and weighted sum of squared residuals.

      wss=0.0
      css=0.0
      do 45 i=1,npoint
           fulln= snu(i)+snuc(i)
           sy(i)=nutoy(fulln,link)
               diag= phi2(fulln,link)
C               if( diag.lt.1e-8 ) diag=1e-8 
c   compute weighted sum of squares 
               wss= wss + DBLE(irep(i))*( (y(i)-sy(i))**2 )/diag
               css= css + DBLE(irep(i))*( (avgy-sy(i))**2 )/diag
 45   continue

      return

      end 

c bernoulli and poisson link functions
c these are called by glisp

      doubleprecision function ytonu(p,link)
      doubleprecision p
      integer link
      if(link.eq.2) then
	if(1-p.lt.1e-8) p=1e-8
        ytonu= dlog(p/(1.0-p))
      else
        ytonu= dlog(p)
      endif
      return
      end

      doubleprecision function nutoy(h,link)
      doubleprecision h,temp
      integer link

      IF (ABS(h).GT.23) THEN
        if (h.gt.23) then 
          h=23
	else
	  h=-23
	endif
      ENDIF
      if(link.eq.2) then
        temp=exp(h)
        nutoy= temp/(1.0+temp)
      else
        nutoy=exp(h)
      endif
      return
      end

      doubleprecision function phi2(h,link)
      doubleprecision h,temp,nutoy
      integer link
      temp= nutoy(h,link)
      if(link.eq.2) then
        if( temp.lt.1e-8 .or. 1-temp.lt.1e-8) then
         phi2=1e-8
        else
         phi2= temp*(1.0-temp)
        endif
      else
	IF( TEMP.LT.1E-8) THEN
         PHI2=1E-8
        ELSE
         phi2= temp
	ENDIF
      endif
      return
      end

 
       subroutine sortm(k,ki,n)
c  heapsort algorithm for sorting on vector of keys k of length n    
c  j f monahan        transcribed from knuth, vol 2, pp 146-7.      
c integer array ki is permuted along with k
 
      real*8 k(1),kk 
      integer ki(1),kki
      integer r             
      if(n.le.1) return    
      l=n/2+1             
      r=n                
  2   if(l.gt.1) go to 1
      kk=k(r)
      kki= ki(r)               
      k(r)=k(1)
      ki(r)=ki(1)  
      r=r-1       
      if(r.eq.1) go to 9   
      go to 3             
  1   l=l-1              
      kk=k(l)
      kki=ki(l) 
  3   j=l       
  4   i=j       
      j=2*j     
      if(j-r) 5,6,8   
  5   if(k(j).lt.k(j+1)) j=j+1   
  6   if(kk.gt.k(j)) go to 8    
  7   k(i)=k(j)
      ki(i)=ki(j) 
      go to 4     
  8   k(i)=kk    
      ki(i)=kki 
      go to 2  
  9   k(1)=kk 
      ki(1)=kki   
      return     
      end       



c
c***** projection pursuit 
c
c***** projection pursuit glim models
c
      subroutine mkpx(ndim,direct,ldx,nobs,x,y,snuc,irep,
     *       px,py,psnuc,prep,index)
      implicit double precision (a-g,o-z)
      real*8 direct(ndim)
      real*8 x(ldx,ndim),y(nobs),snuc(nobs)
      real*8 py(nobs),px(nobs),psnuc(nobs)
      integer irep(nobs),prep(nobs),index(nobs)
      
           do 100 k=1,nobs
              psnuc(k)=snuc(k)
              prep(k)= irep(k)
  100      continue

           do 200 k=1,nobs
               sum=0.0
               do 205 j=1,ndim
                  sum= sum+ direct(j)*x(k,j)
  205          continue
           px(k)=sum

           index(k)=k
  200      continue
           
        call sortm(px,index,nobs)

        do 300 k=1,nobs
           kk= index(k)
           py(k)= y(kk)
           psnuc(k)= snuc(kk)
           prep(k)= irep(kk)
  300   continue
        return
        end


      subroutine mkpxl(idir,nproj,ndim,direct,ldx,nobs,x,y,snuc,irep,
     *       px,py,psnuc,prep,index)
      implicit double precision (a-g,o-z)
      real*8 direct(nproj,ndim)
      real*8 x(ldx,ndim),y(nobs),snuc(nobs)
      real*8 py(nobs),px(nobs),psnuc(nobs)
      integer irep(nobs),prep(nobs),index(nobs)

           do 100 k=1,nobs
              psnuc(k)=snuc(k)
              prep(k)= irep(k)
  100      continue
      
           do 200 k=1,nobs
               sum=0.0
               do 205 j=1,ndim
                  sum= sum+ direct(idir,j)*x(k,j)
  205          continue
           px(k)=sum

           index(k)=k
  200      continue
           
        call sortm(px,index,nobs)
        do 300 k=1,nobs
           kk= index(k)
           py(k)= y(kk)
           psnuc(k)= snuc(kk)
           prep(k)= irep(kk)
  300   continue
        return
        end


      subroutine gcvpx(nobs,irep,px,py,snuc,din,dout,lev)
c
      parameter( nmax=800)
      implicit double precision (a-g,o-z)
      real*8 py(nobs),px(nobs),sy(nmax),snu(nmax),snuc(nobs)
      integer irep(nobs)
      real*8 lamb
      real*8 din(1),dout(1),lev(nmax)

      if(nobs.gt.nmax) then
        bestg=-1
        return
      endif
c***** bug 
      ngl= int(din(1))
      x1l= din(2)    
      x2l= din(3)
      maxit= int(din(4))
      stop= din(5)
      job= int(din(6))
      link= int(din(7))    
cbug     write(*,*) (din(k),k=1, 7)

      if(ngl.gt.1)  step= (x2l-x1l)/(ngl-1)

          if( igl.eq.1) then
            job=0
          else
            job= int(din(6))
          endif       

        do 10 igl=1,ngl

          lamb= dexp( x1l + (igl-1)*step)
cbug      write(*,*) ' call to glisp from gcv job= ', job
c   DO NOT compute the trace at this stage!

          itr=0

          call glisp(lamb,nobs,px,py,sy,snu,snuc,penlty,tr,WSS,
     *       maxit,stop,numit,tstop,job,link,itr,irep,LEV)
       


         if((igl.eq.1).or.(wss.lt.bestg)) then
           bestg=wss
           bestl= lamb
           bestt=tr
         endif
        if(igl.eq.1) dout(4)= tr
        
   10   continue

        dout(1)=bestg
        dout(2)=bestl 
        dout(3)=bestt
        dout(5)= tr

        return
        end

	subroutine mkvert(ndim,svec,ldv,nv,vert,eps,seed)
           real*8 svec(1),vert(ldv,1),eps,xnorm
           real*8 temp(20)
           integer seed
                      
           nv= ndim 

c  generate a set of nv random points on the ndim sphere 
c   project these vectors onto svec  and go out a multiple eps
c  along the component orthogonal to svec
c  renormalize the resulting vector so that it has length one 
c 
           do 30 k=1,nv
              call  ransh(ndim,temp,seed)
              sum=0.0
              do 40 j=1,ndim
                  sum=sum + svec(j)*temp(j)
   40         continue

              xnorm =0.0
              do 60 j=1,ndim
                 vert(k,j)= temp(j) - sum*svec(j)
                 xnorm= xnorm+ vert(k,j)**2
   60         continue
              xnorm= sqrt(xnorm)
              do 70 j=1,ndim
                  vert(k,j) = svec(j) + eps*vert(k,j)/xnorm 
   70         continue

   30      continue

 
           do 100 k=1,nv
              xnorm=0.0
c  constrain the first coordinate to be positive
c  (Commented out by DS)
c             if( vert(k,1).lt.0) vert(k,1)=0.0

              do 110 j=1,ndim
                  xnorm= xnorm+ vert(k,j)**2
  110         continue
              xnorm=sqrt(xnorm)
              do 120 j=1,ndim
                  vert(k,j) = vert(k,j)/xnorm 
  120         continue
  100      continue


      return
      end

     
      subroutine ransh(ndim,direct,seed)
      integer seed
      real*8 direct(ndim)
      real*8 snorm

              direct(1)= abs(unsk(seed))
              snorm= direct(1)**2

             do 110 id=2,ndim
              direct(id)= unsk(seed)
              snorm= snorm+ direct(id)**2
  110        continue
             snorm= dsqrt(snorm)
             do 120 id=1,ndim 
              direct(id)= direct(id)/snorm
  120        continue
            
         return
         end

       subroutine smplx(ldv,nv,ndim,vert,objfun,
     *         worst,best,ldt,nt,test,size)
       parameter (ndmax=20)
       implicit double precision (a-g,o-z)
       real*8 vert(ldv,ndim),objfun(ldv),ctr(ndmax)
       real*8 test(ldt,ndim),templ,temph
       real*8 jump(ndmax), step(ndmax)
       integer worst,best
       nt=4
       jump(1)= dble(nv-1)/dble(nv)
       jump(2)= 1.5
       jump(3)= 2.0
       jump(4)= 3.0       
       
       nvm1= nv-1

       do 5 j=1,ndim
        ctr(j)=0.0
    5  continue

c*** find best and worst vertex
       do 10 k=1,nv
        if((k.eq.1).or.(objfun(k).gt.temph)) then
              temph= objfun(k)
              worst= k
        endif
        if((k.eq.1).or.(objfun(k).lt.templ)) then
              templ= objfun(k)
              best= k
        endif

   10 continue

C**** find center of face opposite worst vertex
      do 20 k=1,nv
         if(k.ne.worst) then
           do 25 j=1,ndim
             ctr(j)= ctr(j)+vert(k,j)/nvm1
   25      continue
         endif
   20 continue   

C***** step = direction from worst to center of face
      do 30 j=1,ndim
          step(j)= ctr(j)- vert(worst,j)
   30 continue


c**** setup points to test  (center and steps .5 1 and 2)
      do 40 it=1,nt
            xnorm=0.0
            do 45 j=1,ndim
                test(it,j)= vert(worst,j)+ step(j)*jump(it)
                xnorm= xnorm + test(it,j)**2
   45       continue
            xnorm= sqrt(xnorm)
            do 55 j=1,ndim
                test(it,j)= test(it,j)/xnorm
   55       continue

c**** constrain test vectors to have a positive first component
C (Commented out by DS; if this is to be included then do it within
C  the normalization loop above, not here, since here it will
C  result in a'a being less than 1)
C           if(test(it,1).lt.0) test(it,1)= 0.0

   40 continue
      
      size=0.0 
      do 100 j=1,ndim
       size= size + (step(j)*jump(1)) **2
  100 continue
      size = dsqrt(size)


      return
      end
c
       real function ran(ix)
c  uniform pseudorandom number generator
c  fortran version of lewis, goodman, miller
c  schrage,  acm toms v.5 (1979) p132
c  first call sets seed to ixx, later ixx ignored
      integer a,p,ix,b15,b16,xhi,xalo,leftlo,fhi,k
      data a/16807/,b15/32768/,b16/65536/,p/2147483647/
c     data ix/0/
c     if(ix.eq.0) ix=ixx
      xhi=ix/b16
      xalo=(ix-xhi*b16)*a
      leftlo=xalo/b16
      fhi=xhi*a+leftlo
      k=fhi/b15
      ix=(((xalo-leftlo*b16)-p)+(fhi-k*b15)*b16)+k
      if(ix.lt.0) ix=ix+p
      ran=float(ix)*4.656612875e-10
      return
      end


      real function unsk(ixx)
c  generates normal(0,1) rv's using knuth's (v.2,2nd ed p125-7) version
c  of kinderman-monahan ratio of uniforms (acmtoms,1977,p257-60) method
      data a/1.7155277/,b/5.136101667/,c/1.036961/
  1   u=ran(ixx)
c  a=sqrt(8/e)
      v=ran(ixx)
      unsk=a*(v-0.5)/u
      zz=unsk*unsk
c  b=4*exp(1/4)
      if(zz.le.5.-b*u) return
c  this is knuth's quick reject test,  c=4*exp(-1.35)
      if(zz.ge.c/u+1.4) go to 1
      if(zz.le.-4.*alog(u)) return
       go to 1
      end

      DOUBLEPRECISION FUNCTION GAUSS(MEAN,SD,SEED)
      INTEGER SEED
      REAL*8 MEAN, SD
	GAUSS=dble(UNSK(SEED))*SD+MEAN
      END
 
C Function to return an integer Poisson(XM) random variable,
C where XM is the parameter (mean and variance). Routine is
C taken from W.H. Press et al. 1986, Numerical Recipes, p 207.
C ISEED is integer*4 seed for the random number generator RAN.
      INTEGER FUNCTION IPOISS(XM,ISEED)
      INTEGER ISEED
      real*8 GAMMLN,XM,G,EM,T,SQ,ALXM,Y,PI
      PARAMETER (PI=3.141592654)
      IF (XM.LT.12.) THEN
        G=EXP(-XM)
        EM=-1.
        T=1.
2       EM=EM+1.
        T=T*RAN(ISEED)
        IF (T.GT.G) GOTO 2
      ELSE
        SQ=SQRT(2.*XM)
        ALXM=DLOG(XM)
        G=XM*ALXM-GAMMLN(XM+1.)
1       Y=TAN(PI*RAN(ISEED))
        EM=SQ*Y+XM
        IF (EM.LT.0.) GOTO 1
        EM=INT(EM)
	t=EM*ALXM-GAMMLN(EM+1.)-G
	if(t.lt.-200.) t=-200.
        T=0.9*(1.+Y**2.)*EXP(t)
c        T=0.9*(1.+Y**2.)*EXP(EM*ALXM-GAMMLN(EM+1.)-G)
        IF (RAN(ISEED).GT.T) GOTO 1
      ENDIF
      IPOISS=EM
      END

      DOUBLEPRECISION FUNCTION GAMMLN(XX)
C Returns the value ln[gamma(XX)] for XX > 0.
C The following variables could be made real*8 for extra precision:
      REAL*8 COF(6),STP,HALF,ONE,FPF,X,TMP,SER,XX
      DATA COF,STP/76.18009,-86.50532,24.0141,-1.231740,.120858E-2,
     +            -.536382E-5,2.506628/
      DATA HALF,ONE,FPF/0.5,1.0,5.5/
      X=XX-ONE
      TMP=X+FPF
      TMP=(X+HALF)*LOG(TMP)-TMP
      SER=ONE
      DO 11 J=1,6
        X=X+ONE
        SER=SER+COF(J)/X
11    CONTINUE
      GAMMLN=TMP+LOG(STP*SER)
      END

C INTEGER function to return a binomial(n,p) random variable,
C where n is the number of trials, and p is the parameter.
C This routine is inefficient if N is large and P is small.
C ISEED is integer*4 seed for the random number generator RAN.
      INTEGER FUNCTION IBINOM(N,P,ISEED)
      INTEGER ISEED,N
      REAL*8 p,x,y,GAUSS
      x=n*p
      y=n*(1-p)
      if (x.lt.20.or.y.lt.20) then
        IBINOM=0
        DO 10 I=1,N
          X=RAN(ISEED)
          IF (X.LE.P) IBINOM=IBINOM+1
10      CONTINUE
      else
        ibinom=nint(gauss(x,sqrt(p*y),iseed))
        if(ibinom.lt.0) ibinom=0
        if(ibinom.gt.n) ibinom=n
      endif
      END

      subroutine setupq(x,wght,y,npoint,v,qty,nmax)
c   put delx=x(.+1)-x(.) into v(.,4)
c   put the three bands of the matrix q-transp*d into
c     v(.,1-3)
c   put the three bands of (d*q)-transp*(d*q) at and 
c     above the diagonal into v(.,5-7)
c   here q is the tridiagonal matrix of order (npoint
c     -2,npoint) that satisfies q-transp*t=0 and wght
c     is the diagonal matrix whose diagonal entries 
c     are the square roots of the weights used in the 
c     penalized least-squares criterion
       implicit double precision (a-g,o-z)
       real*8 wght(nmax),x(nmax),y(nmax)
       real*8 qty(nmax),v(nmax,7)
       real*8 diff,prev
      integer npoint,i,npm1
      npm1=npoint -1
      v(1,4)=x(2)-x(1)
      do 11 i=2,npm1
         v(i,4)=x(i+1) - x(i)
         v(i,1)=wght(i-1)/v(i-1,4)
         v(i,2)=-wght(i)/v(i,4) - wght(i)/v(i-1,4)
   11    v(i,3)=wght(i+1)/v(i,4)
      v(npoint,1)=0.0
      do 12 i=2,npm1
   12    v(i,5)=v(i,1)**2 + v(i,2)**2 + v(i,3)**2
      if(npm1 .lt. 3)go to 14
      do 13 i=3,npm1
   13    v(i-1,6)=v(i-1,2)*v(i,1) + v(i-1,3)*v(i,2)
   14 v(npm1,6)=0.0
      if(npm1 .lt. 4)go to 16
      do 15 i=4,npm1
   15    v(i-2,7)=v(i-2,3)*v(i,1)
   16 v(npm1-1,7)=0.0
      v(npm1,7)=0.0
c  construct q-transp. * y in qty
      prev=(y(2) - y(1))/v(1,4)
      do 21 i=2,npm1
         diff=(y(i+1)-y(i))/v(i,4)
         qty(i)=diff - prev
   21    prev=diff
      return
      end

      subroutine chold(p,v,qty,npoint,u,qu,nmax)
constructs the upper three diagonals in v(i,j),i=2,
c   npoint-1,j=1,3 of the matrix 6*(1-p)*q-transp*
c   (d**2)*q + p*r . (here r is the matrix proportional
c   to q-transp*ksubn*q , where ksubn is the matrix 
c   with elements k(x(i),x(j)) and k is the usual
c   kernel associated with cubic spline smoothing.)
c   the cholesky decomposition of this matrix is computed
c   and stored in v(.,1-3) and the equation system for 
c   the quadratic coefficients of the spline in its 
c   piecewise polynomial representation is solved . the 
c   solution is returned in u.
       real*8 p,qty(nmax),qu(nmax),u(nmax),v(nmax,7)
       real*8 six1mp,twop,ratio,prev
      integer npoint,i,npm1,npm2
      npm1=npoint - 1
c  construct 6*(1-p)*q-transp.*(d**2)*q + p*r
      six1mp=6.*(1. - p)
      twop=2.*p
      do 2 i=2,npm1
         v(i,1)=six1mp*v(i,5) + twop*(v(i-1,4)+v(i,4))
         v(i,2)=six1mp*v(i,6) + p*v(i,4)
    2    v(i,3)=six1mp*v(i,7)
      npm2=npoint - 2
      if(npm2 .ge. 2)go to 10
      u(1)=0.0
      u(2)=qty(2)/v(2,1)
      u(3)=0.0
      go to 41
c  factorization : factorize the matrix as l*b-inv*
c     l-transp , where b is a diagonal matrix and l
c     is upper triangular.
   10 do 20 i=2,npm2
         ratio=v(i,2)/v(i,1)
         v(i+1,1)=v(i+1,1) - ratio*v(i,2)
         v(i+1,2)=v(i+1,2) - ratio*v(i,3)
         v(i,2)=ratio
         ratio=v(i,3)/v(i,1)
         v(i+2,1)=v(i+2,1) - ratio*v(i,3)
   20    v(i,3)=ratio
c  forward substitution
      u(1)=0.0
      v(1,3)=0.0
      u(2)=qty(2)
      do 30 i=2,npm2
   30    u(i+1)=qty(i+1) - v(i,2)*u(i) -v(i-1,3)*u(i-1)
c  back substitution
      u(npoint)=0.0
      u(npm1)=u(npm1)/v(npm1,1)
      do 40 i=npm2,2,-1
   40    u(i)=u(i)/v(i,1) - u(i+1)*v(i,2) - u(i+2)*v(i,3)
c  construct q*u
   41 prev=0.0
      do 50 i=2,npoint
         qu(i)=(u(i)-u(i-1))/v(i-1,4)
         qu(i-1)=qu(i) - prev
   50    prev=qu(i)
      qu(npoint)=-qu(npoint)
      return
      end
      
      subroutine lvrage(npoint,v,wght,six1mp,tr,lev,nmax)
c   constructs the upper three diagonals of (6*(1-p)*
c   q-transp*(d**2)*q + p*r)-inv using the recursion
c   formula in hutchinson,m.f. and dehoog,f.r.(1985).
c   numer. math. 47,99-106, and stores them in v(.,5-7).
c   these are used in post and pre multiplication by
c   q-transp and q to obtain the diagonal elements of
c   the hat matrix which are stored in the vector lev.
c     the trace of the hat matrix is returned in tr.
       real*8 v(nmax,7),lev(nmax),w1,w2,w3,six1mp,tr
       real*8 wght(nmax)
      integer npm1,npm2,npm3,npoint
      npm1=npoint - 1
      npm2=npoint - 2
      npm3=npoint - 3
c   recursion for diagonals of inverse matrix
      v(npm1,5)=1/v(npm1,1)
      v(npm2,6)=-v(npm2,2)*v(npm1,5)
      v(npm2,5)=(1/v(npm2,1)) - v(npm2,6)*v(npm2,2)
      do 10 i=npm3,2,-1
         v(i,7)=-v(i,2)*v(i+1,6) - v(i,3)*v(i+2,5)
         v(i,6)=-v(i,2)*v(i+1,5) - v(i,3)*v(i+1,6)
         v(i,5)=(1/v(i,1))- v(i,2)*v(i,6) - v(i,3)*v(i,7)
   10 continue
c   postmultiply by (d**2)*q-transp and premultiply by q to
c     obtain diagonals of matrix proportional to the 
c     identity minus the hat matrix.
      w1=1/v(1,4)
      w2= -1/v(2,4) - 1/v(1,4)
      w3=1/v(2,4)
      v(1,1)=v(2,5)*w1
      v(2,1)=w2*v(2,5) + w3*v(2,6)
      v(2,2)=w2*v(2,6) + w3*v(3,5)
      lev(1)=1. - (wght(1)**2)*six1mp*w1*v(1,1)
      lev(2)=1. - (wght(2)**2)*six1mp*(w2*v(2,1) + w3*v(2,2))
      tr=lev(1) + lev(2)
      do 20 i=4,npm1
         w1=1/v(i-2,4)
         w2= -1/v(i-1,4) - 1/v(i-2,4)
         w3=1/v(i-1,4)
         v(i-1,1)=v(i-2,5)*w1 + v(i-2,6)*w2 + v(i-2,7)*w3
         v(i-1,2)=v(i-2,6)*w1 + v(i-1,5)*w2 + v(i-1,6)*w3
         v(i-1,3)=v(i-2,7)*w1 + v(i-1,6)*w2 + v(i,5)*w3
         lev(i-1)=1. - (wght(i-1)**2)*six1mp*(w1*v(i-1,1) 
     .             + w2*v(i-1,2) + w3*v(i-1,3))
         tr= tr + lev(i-1)
   20 continue
      w1=1/v(npm2,4)
      w2= -1/v(npm1,4) - 1/v(npm2,4)
      w3=1/v(npm1,4)
      v(npoint,1)=v(npm1,5)*w3
      v(npm1,1)=v(npm2,5)*w1 + v(npm2,6)*w2
      v(npm1,2)=v(npm2,6)*w1 + v(npm1,5)*w2
      lev(npm1)=1. - (wght(npm1)**2)*six1mp*(w1*v(npm1,1)
     .             + w2*v(npm1,2))
      lev(npoint)=1. - (wght(npoint)**2)*six1mp*w3*v(npoint,1)
      tr= tr + lev(npm1) + lev(npoint)
      return 
      end

c
c
      subroutine smths(lamb,nobs,x,y,wght,sy,penlty
     + ,trace,vlam,itr,ierr,lev)

c computes a cubic smoothing spline fit to a set of data given
c npoint(=number of data values) and lambda(=value of
c the smoothing parameter). the code is adapted from a
c program in deboor,c.(1978).a practical guide to splines.
c springer-verlag : new york. an o(npoint) algorithm
c suggested by hutchinson and dehoog is used to compute
c lvrage values and construct confidence intervals.
c Adapted from Randy Eubank Texas A&M
c
c wght are in the scale of st.dev.      
      parameter (nmax=800)
      implicit real*8 (a-g,o-z)
      real*8 wght(nmax),x(nmax),y(nmax),sy(nmax)
      real*8 a(nmax,4),v(nmax,7)
      real*8 p,six1mp,lev(nmax),trace,vlam,lamb
      real*8 ux(nmax),uy(nmax), uw(nmax)
      integer ind(nmax)
      integer npoint,nobs
      data eps / 1e-7/

      if( npoint.gt.nmax) then
           ierr=1
           return
       endif
C construct vector consisting of unique observations. 
       jj=1
       ux(jj)= x(1)
       uy(jj)= y(1)
       uw(jj)= wght(1)
       ind(1)=jj

       do 10 k=2,nobs
C cut here ----------------------------------------
          if( abs( ux(jj)-x(k)).lt.eps) then
            temp1=  uw(jj)**2
            temp2=  wght(jj)**2
            temp3 = (1/temp1 + 1/temp2)
            temp3= 1/temp3
            uy(jj)=  ( uy(jj)/temp1 + y(k)/temp2)*temp3
            uw(jj)= sqrt(temp3)
c cut here ------------------------------------------

C Replace code between above cuts with the code below, which is just
C clearer than above code, it does the same thing. Remove "CC" below
C to implement
c**** we have a repeat observation, update weight and  find the weighted   
c***** average at this point  
c***** Note that passed weights are in units of "standard deviations" while
c***** the weights should be added in the scale of reciprocal variances. 
c***** please refer to the form of the minimization problem
c***** The reason for this way of aggregating comes from the form
c**** of least squares minimization. 
c**** temp variables are in scale of 1/var 
CC         if( abs( ux(jj)-x(k)).lt.eps) then  
CC          temp1=  1.0d0/uw(jj)**2  
CC          temp2=  1.0d0/wght(k)**2 
CC          temp3 = (temp1 + temp2)  
CC          uy(jj)=  ( uy(jj)*temp1 + y(k)*temp2)/temp3  
CC          uw(jj)= 1.0d0/dsqrt(temp3)  
C ----------------------------------------------------

          else
            jj= jj+1
            ux(jj)= x(k)
            uy(jj)= y(k)
            uw(jj)= wght(k)
          endif
           ind(k)=jj
   10 continue
      npoint= jj
c     do 15 k=1,npoint
c     write(*,*)  k, ux(k),uy(k),uw(k) 
c  15 continue


c  scale change to convert lambda from [0,1] scale to 
c range of the data

      iq1 = int(.25*npoint+ 1)
      iq3 = int(.75*npoint+ 1)
      scal= (( ux(iq3)-ux(iq1) )*2)**3
c scale smoothing parameter for B-spline algorithm
      P=1/(npoint*lamb*scal+ 1) 

      call setupq(ux,uw,uy,npoint,v,a(1,4),nmax)
      call chold(p,v,a(1,4),npoint,a(1,3),a(1,1),nmax)

c  compute piecewise polynomial coefficients and the
c     sum of squared errors. the fitted values are 
c     stored in a(.,1). linear,quadratic and cubic
c     coefficients are stored in a(.,2-4). 

      six1mp=6.*(1.-p)
      do 60 k=1,nobs
c         Locate unique x associated with the kth observation
c         ind is an array such that ind(k) is the index of the unique observation
C         associated with the data point k. Subtle way to retrieve the predicted y's! 
        i= ind(k)
c         Fill in predicted values based on estimate from unique 
c         data set
        sy(k)=uy(i) - six1mp*(uw(i)**2)*a(i,1)
   60   continue


      if (itr.ge.1) then 
       call lvrage(npoint,v,uw,six1mp,trace,lev,nmax)
      else 
       trace= -1
      endif

      rss=0.0

      do 100 k=1,nobs
         rss= rss + ((y(k)-sy(k))/wght(k))**2
  100 continue

      vlam=rss

      ierr= npoint
      return
      end

      SUBROUTINE PENLIK(Y,IREP,SNU,PENLTY,LINK,LAMB,NPOINT,LOGLIK)
C Subroutine to calculate penalized likelihood for binomial and Poisson
C data. That likelihood is likelihood-lamb*penlty.
C Y is the dependent variable (average of all Y's for a given X)
C IREP is the number of Y values for a given X. 
C SNU are the predicted Y values on the transformed scale 
C   (to get yhat use SY=nutoy(SNU).
C PENLTY comes from smths
C LINK is the link function 1=normal, 2=binomial, 3=Poisson
C LAMB is lambda (NOT on natural log scale)
C NPOINT is the number of cases
C LOGLIK is the penalized likelihood
      INTEGER NPOINT,LINK
      INTEGER IREP(NPOINT)
      REAL*8 Y(NPOINT),SNU(NPOINT),PENLTY,LAMB,LOGLIK

      LOGLIK=0.0D0
      IF (LINK.EQ.1) THEN
C normal case (not done yet)

      ELSEIF (LINK.EQ.2) THEN
C binomial
        DO 10 I=1,NPOINT
          LOGLIK=LOGLIK + 
     +     DBLE(IREP(I)) * ( Y(I)*SNU(I) - DLOG(1.0+DEXP(SNU(I))) )
10      CONTINUE
      ELSE
C poisson
        DO 20 I=1,NPOINT
          LOGLIK=LOGLIK +
     +     DBLE(IREP(I)) * (-DEXP(SNU(I)) + Y(I)*SNU(I) )     
20      CONTINUE
      ENDIF

      LOGLIK= LOGLIK - LAMB * PENLTY
c      WRITE(*,*) 'Penalized likelihood = ',LOGLIK

      END


      SUBROUTINE REBOOT(Y,SYOLD,IREP,NPOINT,LINK,ERRVAR,ISEED)
C Subroutine to collect a bootstrap sample of Y from the YHAT's in SYOLD.
C NPOINT is the number of values of Y, SY and SYOLD. LINK is set on
C input: LINK=1 indicates Y are normal, LINK=2 indicates binomial, and
C LINK=3 indicates Poisson. In the normal case ERRVAR is the variance
C of the deviations around the estimate SYOLD. Otherwise ERRVAR not used. 
      INTEGER LINK,NPOINT,IBINOM,IPOISS,IREP(NPOINT),ISEED,IERR
      REAL*8 Y(NPOINT),GAUSS,ERRVAR,SYOLD(NPOINT)
C     Create a bootstrap sample
10    IF(LINK.EQ.1) THEN
        DO 20 I=1,NPOINT
          Y(I)=SYOLD(I)+GAUSS(0.0d0,SQRT(ERRVAR/dble(IREP(I))),ISEED)
20      CONTINUE
      ELSEIF (LINK.EQ.2) THEN
        DO 40 I=1,NPOINT
          Y(I)=dble(IBINOM(IREP(I),SYOLD(I),ISEED))/dble(IREP(I))
40      CONTINUE
      ELSE
        DO 60 I=1,NPOINT
          Y(I)=dble(IPOISS(dble(IREP(I))*SYOLD(I),ISEED))/dble(IREP(I))
60      CONTINUE
      ENDIF
      CALL YTEST(Y,NPOINT,LINK,1,IERR)
      IF(IERR.EQ.1) THEN
	WRITE(*,*) 
     *  'Notice: a random sample with no variance in Y was discarded'
	GOTO 10
      ENDIF
      END

      doubleprecision function varianc(x,irep,nobs)
C Function to compute sample variance of data
C in a REAL*8 array X. IREP gives the
C frequency of X=X(i). NOBS is the size of arrays X, IREP.
      integer nobs,irep(nobs)
      real*8 x(nobs),sumx,var,n
      sumx=0.0
      var=0.0
      n=0.0
      do 10 i=1,nobs
        sumx = sumx + irep(i) * x(i)
        var=var+ dble(irep(i))*( x(i)**2 )
        n=n+irep(i)
10    continue
      varianc=( var-(sumx**2)/n )/(n-1.0)
      end

      doubleprecision function acorr(a,b,ndim,job)
c Computes the product of two vectors a and b.
c If job not=0 then product is computed between a and -b
      integer ndim,job
      real*8 a(ndim),b(ndim),sum
      sum=0.0d0
      if(job.eq.0) then
        do 10 i=1,ndim
	  sum=sum+a(i)*b(i)
10      continue
      else
	do 20 i=1,ndim
	  sum=sum+a(i)*(-1)*b(i)
20      continue
      endif
      acorr=sum
      return
      end

      SUBROUTINE LOGLIK(Y,YHAT,IREP,NOBS,LINK,ERRVAR,LL)
      INTEGER NOBS,IREP(NOBS),LINK
      REAL*8 Y(NOBS),YHAT(NOBS),LL,ERRVAR,LAMBDA,X,GAMMLN,PI
      PARAMETER (PI=3.141592654)
      LL=0.0D0
      IF (LINK.EQ.1) THEN
       DO 10 I=1,NOBS
	 X=ERRVAR/DBLE(IREP(I))
	 LL=LL+ (-.5)*( LOG(2.*PI*X) + ((Y(I)-YHAT(I))**2.)/X )
10     CONTINUE
      ELSEIF(LINK.EQ.2) THEN
       DO 20 I=1,NOBS
	 LL=LL+DBLE(IREP(I))*(Y(I)*LOG(YHAT(I))+(1-Y(I))*LOG(1-YHAT(I)))
20     CONTINUE
      ELSE
       DO 30 I=1,NOBS
	 LAMBDA=DBLE(IREP(I))*YHAT(I)
	 X=DBLE(IREP(I))*Y(I)
	 LL=LL+( -LAMBDA + X*LOG(LAMBDA) - GAMMLN(X+1.) )
30     CONTINUE
      ENDIF
      RETURN
      END
