$nofloatcalls
$include : '\ftn\forexec.inc'
c Don't forget to link with \ftn\CEXEC.LIB
c ------------------------------------------------------------------
      subroutine go(j)
      integer*2 system,j
      if(j.eq.1) then
       i=system('pp.exe < pp.in > pp.out'c)
      elseif(j.eq.2) then
       i=system('pp.exe < pp.in'c)
      endif
      write (*,*)
      end
c The above 12 lines are specific to my DOS FORTRAN77 compiler,
c and allow me to execute system commands from inside the program
c "SURFACE". To compile this program successfully, you may need
c to tailor this part of the code to the needs of your own compiler.
c ------------------------------------------------------------------

      program surface
c Reads in parameter values and options from terminal, and
c creates ".in" file for the program "pp"
       real*4 eps,stop,eps2,lmin,lmax,x
       integer*2 j
       integer ndim,irep,nd,mbig,mrid,ndst,link,option,nlam,nback,
     +    iprint,job,nit,maxit,seed,input,nboot
       character*50 infile
       logical yes1,yes2,indeed
       parameter(mbig=4,nd=12)

       inquire(file='pp.exe',exist=yes1)
       if(.not.yes1) then
           write(*,'(/a,a/)') 
     +  ' "surface" only works if program "pp" is in the',
     +  ' current directory'
           stop
       endif


10      write (*,'(///a//a)')
     +' Estimating fitness surface using projection pursuit regression',
     +'                 Version 1.1 (24 June, 1993)'

20       write(*,'(/a)')
     +  ' Enter name of file containing data'
       read (*,'(a50)',err=20) infile
       inquire(file=infile,exist=indeed)
       if (.not.indeed) then
         write(*,'(/a)') 
     +    ' Error: file does not exist, check filename and directory'
         goto 20
       endif

30      write (*,'(/a//a/a//a/a//a)')
     +' Each line of file may contain data in either of two ways:',
     +' 1. ( Y Z1 Z2 ... ) where Y is survival or reproductive success',
     +'    and Z1, Z2, ... are the independent Z-variables',
     +' 2. ( Y Z1 Z2 ... N ) where Y is the average Y-value',
     +'    of N individuals having the same values of Z1, Z2, ...',
     +' Enter your file structure (1 or 2)'
        read (*,*,err=30) irep
       if(irep.ne.1.and.irep.ne.2) goto 30
       irep=irep-1

40       write(*,'(/a)')
     +  ' How many Z-variables are there?'
       read (*,*) ndim
       if (ndim.gt.nd) then
         write(*,'(/a,i3,a/a)') 
     +  ' Sorry, program can handle a maximum of',nd,' Z-variables',
     +  ' Reset "nd" parameter in pp.f, ppsubs.f, and surface.f' 
       stop
       endif

50       write(*,'(/a)')
     +  ' How many projections (f1, f2, ...) do you want?'
       read(*,*) mrid
       if (mrid.gt.mbig) then
         write(*,'(/a,i3,a/a)') 
     +  ' Sorry, program can handle a maximum of',mbig,' projections',
     +  ' Reset "mbig" parameter in pp.f, ppsubs.f, and surface.f' 
       stop
       endif

60       write(*,'(/a/a/a)')
     +  ' Program searches random directions to find best f1, f2, ...',
     +  ' How many directions do you want sampled?',
     +  ' (make this number large: e.g. 5000)'
       read(*,*) ndst

70       write(*,'(/a)') 
     +  ' Enter integer seed for random number generator'
       read(*,*,err=70) x
       seed=nint(x)

80      write (*,'(/a/a/a/a)')
     +  ' Enter model type:',
     +  ' 1. Y is normal  ',
     +  ' 2. Y is binomial (0 or 1)  -- logistic link ',
     +  ' 3. Y is poisson            -- natural log link'
        read (*,*,err=80) link
       if(link.lt.1.or.link.gt.3) goto 80

100     write (*,'(/a/a/a)')
     +  ' Enter option number:',
     +  ' 1. Test a range of values for lambda (grid search)',
     +  ' 2. Use only a single value of lambda'
        read (*,*,err=100) option
        if(option.ne.1.and.option.ne.2) goto 100

110       if(option.eq.1) then
         write(*,'(/a)') ' Enter smallest lambda to test'
         read(*,*,err=110) lmin
         write(*,'(/a)') ' Enter largest lambda to test'
         read(*,*,err=110) lmax
         if(lmin.ge.lmax) then
           write(*,*) 'Error: enter smallest then largest'
           goto 110
         endif
111         write(*,'(/a)') ' Enter number of lambdas to test'
         read(*,*,err=111) nlam
         if(nlam.le.1) nlam=2
       else
112         write(*,'(/a)') ' Enter value for lambda'
         read(*,*,err=112) lmin
         lmax=lmin
         nlam=1
120       write(*,'(/a/a/a/a,i2/a)') 
     +    ' Statistical inference using the bootstrap:',
     +    ' Enter option number:',
     +    ' 1. SE''s for projection coefficients and predicted Y',
     +    ' 2. Significance test of projection',mrid,
     +    ' 3. No statistical inference desired'
          read(*,*,err=120) input
          if(input.eq.1.or.input.eq.2) then
            if(input.eq.2) mrid=(-1)*mrid
130         write(*,'(/a)')
     +      ' Enter number of bootstrap replicates desired'
            read(*,*,err=130) nboot
            if(nboot.le.1) then
                write(*,'(a)')
     +          ' Error: nboot must exceed 1'
                goto 130
            endif
          else
            nboot=0
          endif
       endif

       eps=.1
       eps2=.4
       nback=5
       if(abs(mrid).eq.1) nback=2
       nit=5
       maxit=5
       stop=.01
       job=0
       iprint=0

       open (8,file='pp.in',status='new')
       write(*,'(/a)') ' File "pp.in" created'
       write(*,*) ' See it to inspect all parameter settings'

       write(8,*) 
     +  '17  Number of parameters to read in'
       write(8,'(i2,a)') ndim,
     +  '   ndim= Number of Z-variables'
       write(8,'(i7,a)') ndst,
     +  '   ndist= Number of directions in search'
       write(8,'(i2,a,a)') mrid,
     +  '  mrid= Number of projections (<0 tests signif of last',
     +  ' projection)'
        write(8,'(f4.3,a)') eps,
     +  '   eps= initial size of search region for simplex'
       write(8,'(i2,a)') nback,
     +  '   nback= number of backfit iterations'
       write(8,'(i2,a)') nit,
     +'   nit= number of iterations in simplex search (0=addit. model)'
       write(8,'(i2,a)') nlam,
     +  '   nlam= number of lambdas to search over'
       write(8,'(f6.2,a)') lmin,
     +  '   lmin= smallest lambda of range (natural log scale)'
       write(8,'(f6.2,a)') lmax,
     +  '   lmin= largest lambda of range (natural log scale)'
       write(8,'(i2,a)') maxit,
     +  '   maxit= max number of iterations for spline fit'
       write(8,'(f4.3,a)') stop,
     +  '   stop= convergence tolerance for spline fit'
       write(8,'(i2,a)') job,
     +  '   job=1 use previous fit as the start values'
       write(8,'(i2,a)') link,
     +  '   link 1= normal 2= binomial 3=poisson'
       write(8,'(i2,a)') irep,
     +  '   irep 1=repl. measurements N in last column of data file'
       write(8,'(i2,a)') iprint,
     +  '   iprint 0 = minimal output 2= intermediate output'
       write(8,'(f4.3,a)') eps2,
     +  '   eps2= same as eps but used after first coarse search'
       write(8,'(i4,a)') nboot,
     +  '  nboot= Number of bootstrap replications to carry out'
       write(8,'(i10,a)') seed,'   random number seed'
       write(8,'(a)') infile

       close(8)

140     write (*,'(/a/a/a)')
     +  ' Enter option number:',
     +  ' 1. Write results onto screen below',
     +  ' 2. Send results to a file'
        read (*,*,err=140) option
       if(option.eq.2) then
         write(*,'(/a/)') ' Output will be sent to file "pp.out"'
           j=1
           write(*,*) 'pp < pp.in > pp.out'
       elseif(option.eq.1) then
           j=2
           write(*,*) 'pp < pp.in'
       endif
       if(j.ge.1.and.j.le.2) call go(j)

       end
